#include <stdio.h>
#include <stdlib.h>
#include <string.h>

FILE *olde;
FILE *newe;
int options=0;

int transpose();
int capture();
int offset();

int main(int argc, char *argv[])
{
for(;;)
    {system("cls");
    printf("\nCustom Robo Text Transposer\n---------------------------\nReturn\ttranspose binary (.bin) file\n1\t%sable color in output\n2\t%sable unhandled value messages\n3\t%stoggle jump for compressed files\nSpacebar\tquit\n\n", options & 1 ? "en":"dis", options & 4 ? "dis":"en", options & 8 ? "un":"");
    switch(getch())
        {case '\r':
            capture();
            break;
        case '1':
            options = options ^ 0x1;
            break;
        case '2':
            options = options ^ 0x2;
            break;
        case '3':
            options = options ^ 0x8;
            break;

        case ' ':
            return 0;
            break;
        }    
    }
   return 0;    
}    

int capture()
{char filename[130];
  while((olde = fopen(filename,"rb"))==NULL)
        {printf("\nFile to open: ", filename);
        strcpy(filename,"\0");
        gets(filename);}

        strtok(filename,".");
        if(options & 2) strcat(filename, " -tags");
        else if(options & 1) strcat(filename, " -color");
        else strcat(filename, " new");
        strcat(filename, ".htm");

  while((newe = fopen(filename,"wb+"))==NULL)
        {printf("\ncouldn't open %s\nName output file: ", filename);
        strcpy(filename,"\0");
        gets(filename);}

  fflush(stdin);
  /*header*/
  fputs("<HTML lang=ja><HEAD><TITLE>",newe);
  fputs(filename,newe);
  fputs("</TITLE>\n",newe);
  fputs("<META http-equiv=Content-Type content=\"text/html; charset=Shift_JIS\">\n</HEAD>",newe);

  rewind(olde);
  if(options & 8)
    {offset();
      fputs("<body bgcolor=333388 text=FFFFFF>",newe);
      }
  else fputs("<body bgcolor=FFFFFF text=000000>",newe);    
  transpose(filename);
  
  fputs("</body></html>",newe);
  
  fclose(olde);
  fclose(newe);
  
  printf("\n\nFinished.\nTransposed text is in %s.\n\n", filename);
  return 0;
}

int transpose()
{printf("\ntransposing...  be patient");
unsigned short x,y;
char display[30];
FILE *table;

    
    for(;feof(olde) == 0;)
        {x=fgetc(olde);
            /*zeroes*/
            if(x==0)
              {
              y=fgetc(olde);
              
               switch(y)
                     {default:
                         ungetc(y,olde);
                         if(options & 8) fputs("<br>\n",newe);
                         break;
                         /*if it isn't explicitly a 00xx type, this should unget the following byte
                         that way, odd #ed 00 termination along word values will be recognized
                         this only works, however, if the following string isn't ASCII starting with said values...
                         otherwise, if errors occur, disable all 00xx types for proper output.
                         
                         handling 00: keep reading until not an 00
                         then, unget the value and a single zero
                         seemingly accurate, but this results in a messy file...*/
                     case 0x0:
                         for(;y==0;)
                         {y=fgetc(olde);}
                         ungetc(y,olde);
                         ungetc(0,olde);
                         fputs("<hr>\n",newe);
                     case 0x5A:
                         fputs("<br soft>",newe);
                         break;
                     /*colors (the ones that are used at least)*/
                      /*blue*/
                      case 0x48:
                      if(options ^ 1) fputs("<font color=6666FF>",newe);
                      break;
                      /*red*/
                      case 0x49:
                      case 0x59:
                      if(options ^ 1) fputs("<font color=FF0000>",newe);
                      break;
                      /*purple*/
                      case 0x4A:
                      if(options ^ 1) fputs("<font color=FF00FF>",newe);
                      break;
                      /*green*/
                      case 0x4B:
                      if(options ^ 1) fputs("<font color=00FF00>",newe);
                      break;
                     /*cyan*/
                      case 0x4C:
                      if(options ^ 1) fputs("<font color=0000FF>",newe);
                      break;
                     /*yellow*/
                      case 0x4D:
                      if(options ^ 1) fputs("<font color=FFCC00>",newe);
                      break;
                     /*white (black in this case)*/
                      case 0x4E:
                      if(options ^ 1) fputs("<font color=000000>",newe);
                      break;
                      
                     }/*end switch(y)*/
              }/*end zeroes*/
              
            /*catch basic image types*/
            else if(x==0x23)
                 {y=fgetc(olde);
                 switch(y)
                       {case 0x23:
                             fputs("<img src=\"images/2323.png\">",newe);
                             break;
                       case 0x24:
                             fputs("<img src=\"images/2324.png\">",newe);
                             break;
                       case 0x30:
                             fputs("<img src=\"images/2330.png\">",newe);
                             break;
                       case 0x31:
                             fputs("<img src=\"images/2331.png\">",newe);
                             break;
                       case 0x32:
                             fputs("<img src=\"images/2332.png\">",newe);
                             break;
                       case 0x33:
                             fputs("<img src=\"images/2333.png\">",newe);
                             break;
                       case 0x34:
                             fputs("<img src=\"images/2334.png\">",newe);
                             break;
                       case 0x35:
                             fputs("<img src=\"images/2335.png\">",newe);
                             break;
                       case 0x36:
                             fputs("<img src=\"images/2336.png\">",newe);
                             break;
                       case 0x37:
                             fputs("<img src=\"images/2337.png\">",newe);
                             break;
                       case 0x38:
                             fputs("<img src=\"images/2338.png\">",newe);
                             break;
                       case 0x39:
                             fputs("<img src=\"images/2339.png\">",newe);
                             break;
                       case 0x40:
                             fputs("<img src=\"images/2340.png\">",newe);
                             break;
                       case 0x42:
                             fputs("<img src=\"images/2342.png\">",newe);
                             break;
                       case 0x43:
                             fputs("<img src=\"images/2343.png\">",newe);
                             break;
                       case 0x44:
                             fputs("<img src=\"images/2344.png\">",newe);
                             break;
                       case 0x46:
                             fputs("<img src=\"images/2346.png\">",newe);
                             break;
                       case 0x47:
                             fputs("<img src=\"images/2347.png\">",newe);
                             break;
                       case 0x48:
                             fputs("<img src=\"images/2348.png\">",newe);
                             break;
                       case 0x49:
                             fputs("<img src=\"images/2349.png\">",newe);
                             break;
                       case 0x4F:
                             fputs("<img src=\"images/234F.png\">",newe);
                             break;
                       case 0x50:
                             fputs("<img src=\"images/2350.png\">",newe);
                             break;
                       case 0x53:
                             fputs("<img src=\"images/2353.png\">",newe);
                             break;
                       case 0x54:
                             fputs("<img src=\"images/2354.png\">",newe);
                             break;
                       case 0x55:
                             fputs("<img src=\"images/2355.png\">",newe);
                             break;
                       case 0x59:
                             fputs("<img src=\"images/2359.png\">",newe);
                             break;
                       case 0x61:
                             fputs("<img src=\"images/2361.png\">",newe);
                             break;
                       case 0x62:
                             fputs("<img src=\"images/2362.png\">",newe);
                             break;
                       case 0x63:
                             fputs("<img src=\"images/2363.png\">",newe);
                             break;
                       case 0x64:
                             fputs("<img src=\"images/2364.png\">",newe);
                             break;
                       case 0x65:
                             fputs("<img src=\"images/2365.png\">",newe);
                             break;
                       case 0x66:
                             fputs("<img src=\"images/2366.png\">",newe);
                             break;
                       case 0x67:
                             fputs("<img src=\"images/2367.png\">",newe);
                             break;
                       case 0x69:
                             fputs("<img src=\"images/2369.png\">",newe);
                             break;
                       case 0x6B:
                             fputs("<img src=\"images/236B.png\">",newe);
                             break;
                       case 0x6C:
                             fputs("<img src=\"images/236C.png\">",newe);
                             break;
                       case 0x6D:
                             fputs("<img src=\"images/236D.png\">",newe);
                             break;
                       case 0x6E:
                             fputs("<img src=\"images/236E.png\">",newe);
                             break;
                       case 0x72:
                             fputs("<img src=\"images/2372.png\">",newe);
                             break;
                       case 0x73:
                             fputs("<img src=\"images/2373.png\">",newe);
                             break;
                       case 0x74:
                             fputs("<img src=\"images/2374.png\">",newe);
                             break;
                       case 0x77:
                             fputs("<img src=\"images/2377.png\">",newe);
                             break;
                       case 0x78:
                             fputs("<img src=\"images/2378.png\">",newe);
                             break;
                       case 0x7A:
                             fputs("<img src=\"images/237A.png\">",newe);
                             break;
                       default:
                           ungetc(y,olde);
                           fputc(x,newe);
                           break;
                       }    
                 }   
                  
            /*catch the crazy typecast characters*/
            else if(x==0x24)
                 {y=fgetc(olde);
                     switch(y)
                           {/*playername and darkplayername*/
                           case 0x41:
                           case 0x42:
                               fgetc(olde);
                               fgetc(olde);
                               fputs(" (player) ",newe);
                               break;
                           /*color casting $C## -  #=colorvalue*/
                           case 0x43:
                               fgetc(olde);
                               y=fgetc(olde);
                               switch(y)
                                     {/*blue*/
                                     case 0x31:
                                     if(options ^ 1) fputs("<font color=6666FF>",newe);
                                     break;
                                     /*red*/
                                     case 0x32:
                                     if(options ^ 1) fputs("<font color=FF0000>",newe);
                                     break;
                                     /*purple*/
                                     case 0x33:
                                     if(options ^ 1) fputs("<font color=FF00FF>",newe);
                                     break;
                                     /*green*/
                                     case 0x34:
                                     if(options ^ 1) fputs("<font color=00FF00>",newe);
                                     break;
                                     /*cyan*/
                                     case 0x35:
                                     if(options ^ 1) fputs("<font color=0000FF>",newe);
                                     break;
                                     /*yellow*/
                                     case 0x36:
                                     if(options ^ 1) fputs("<font color=FFCC00>",newe);
                                     break;
                                     /*white*/
                                     case 0x37:
                                     if(options ^ 1) fputs("<font color=FFFFFF>",newe);
                                     break;
                                     }/*colorcasting*/
                               break;
                           case 0x44:
                               /*$D - darken screen*/
                               fputs("\n<br soft>-darken screen and wait for input-<br>\n",newe);
                               break;
                           case 0x46:
                               /*$F##charname - display character image#*/
                               x=fgetc(olde);
                               y=fgetc(olde);
                               fputs(" -char image- ",newe);
                               break;
                           case 0x50:
                               /*$P - new paragraph and clear screen*/
                               fputs("<p>\n",newe);
                               break;
                           case 0x52:
                               /*$R - return (newline)*/
                               fputs("<br soft>\n",newe);
                               break;
                           case 0x57:
                               /*$W - wait for player to press A*/
                               fputs("\n<br soft> -Press A to Continue-",newe);
                               break;
                           default:
                               ungetc(y,olde);
                               fputc(x,newe);
                               break;
                           }/*switch(y)*/    
                 }/*end crazy typecast characters*/
            
            /*catch all straight ASCII*/
            else if(x<0x7F) 
                        {/*need a binary stream now...*/
                        putc(x,newe);
                        }  
                          
            /*catch the japanese text characters*/
            else if(x>0xA0 && x<0xD0)
              {/*need a binary stream now...*/
                  y=fgetc(olde);
                  
                  /*for each set of character types, change the stuff offset to windows standard*/
                  /*correct second value for initial offset*/
                    y -= 0x61;
                    /*if the type is divisibile by two, it is in the second half of the codetype
                    therefore, subtract one from the codetype, and add to push value to 9E
                    later, will add 1 to all values over 7F, accounting for the EOF value gap*/
                    if((x % 2) == 0)
                       {x--;
                       y += 0x5E;
                       }    
                    /*correct codetypes.  87 is a literal codetype, so this retains it*/
                    x -= 0x20;
                    x = x - ((x-0x81)/2);
                    if(x==0x84) x=0x87;

                    /*compensate for lack of xx7F values (EOF value gap)*/
                    if(y >= 0x7f) y++;
                    /*special case for roman numeral II*/
                    if(x==0x81 && y==0xAC)
                      {x=0x87;
                      y=0x55;}

                      /*output the coded value (finally...)*/
                  fputc(x,newe);
                  fputc(y,newe);
              
              }/*end catch the japanese text characters*/
              
        }    
    
    return 0;
}

/*used to save time with certain compressed binaries*/
int offset(){
    unsigned long buffy=0;
    
    /*read third long, swap it, then jump to address*/
    fseek(olde,8,SEEK_SET);
    while(ftell(olde)<0xC)
        {buffy = buffy << 8;
        buffy+=fgetc(olde);}
        
    fseek(olde,buffy,SEEK_SET);
    return 0;}    
